import { IComponentInputProps, IComponentsInfoMap, IPackageJson } from '../types/common';
import { IMaterialItem } from '../../weapps-core/types/material';
export { getMetaInfoBySourceKey, isArray, isPlainObject, deepDeal, simpleDeepClone, deepDealSchema, getFileNameByUrl, } from '../../generator/util/common';
export declare type PromiseResult<T> = Promise<[null, T] | [Error, null]>;
export declare function promiseWrapper<T>(p: Promise<T>): PromiseResult<T>;
export declare function getCurrentPackageJson(): {
    name: any;
    version: any;
} | undefined;
export declare function getSelfPackageJson(): IPackageJson | undefined;
export declare function JsonToStringWithVariableName(copyJson: any): string;
export declare function requireUncached(module: any): any;
export declare function removeRequireUncached(path?: string): void;
export declare function getInputProps(componentsMetaMap: IComponentsInfoMap): IComponentInputProps;
export declare function getComponentsInfo(appBuildDir: string, dependencies: IMaterialItem[]): Promise<IComponentsInfoMap>;
export declare function getScopeComponents(appBuildDir: string, dependencies: IMaterialItem[]): Promise<IComponentsInfoMap>;
export declare function getYyptConfigInfo(extraData: any): Promise<{
    yyptAppKey: any;
    reportUrl: any;
    stopReport: boolean;
}>;
export declare function writeLibCommonRes2file(gItem: IMaterialItem, codeDir: string): Promise<void>;
export declare function readComponentLibMata(libDir: any): {
    version?: string;
    schemaVersion?: string;
    styles?: IMaterialItem['styles'];
    dependencies?: IMaterialItem['dependencies'];
    components: {
        [componentName: string]: {
            name: string;
            meta: Object;
        };
    };
} | null;
export declare function isOfficialComponentLib(name: any, version: any): boolean;
//# sourceMappingURL=common.d.ts.map