"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanDir = exports.removeFile = exports.writeFile = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const lodash_template_1 = __importDefault(require("lodash.template"));
const junk = __importStar(require("../util/junk"));
const generatedFileContents = {};
function generateFiles(appFileData, srcDir, dstDir, ctx) {
    return __awaiter(this, void 0, void 0, function* () {
        const filesGenerated = [];
        for (const file in appFileData) {
            const fileNameList = file.split('|');
            const srcFileName = fileNameList[0];
            const outFileName = fileNameList[1] || fileNameList[0];
            const tplStr = yield fs_extra_1.default.readFile(path_1.default.join(srcDir, srcFileName), {
                encoding: 'utf8',
            });
            let generatedCode = (0, lodash_template_1.default)(tplStr, { interpolate: /<%=([\s\S]+?)%>/ })(appFileData[file]);
            const outFile = path_1.default.resolve(dstDir, outFileName.replace(/\.tpl$/, ''));
            if (yield writeFile(outFile, generatedCode)) {
                filesGenerated.push(outFileName);
            }
        }
        return filesGenerated;
    });
}
exports.default = generateFiles;
function writeFile(outFile, content) {
    return __awaiter(this, void 0, void 0, function* () {
        const generated = generatedFileContents[outFile];
        if (generated === content) {
            return false;
        }
        console.log(outFile);
        yield fs_extra_1.default.ensureFile(outFile);
        yield fs_extra_1.default.writeFile(outFile, content);
        generatedFileContents[outFile] = content;
        return true;
    });
}
exports.writeFile = writeFile;
function removeFile(file) {
    console.log('Removing ' + file);
    Object.keys(generatedFileContents).map((cachedFile) => {
        if (cachedFile.indexOf(file) === 0) {
            delete generatedFileContents[cachedFile];
        }
    });
    return fs_extra_1.default.removeSync(file);
}
exports.removeFile = removeFile;
function cleanDir(dir, allowedFiles) {
    if (!fs_extra_1.default.existsSync(dir))
        return;
    const allFiles = fs_extra_1.default.readdirSync(dir).filter(junk.not);
    allFiles.map((file) => {
        if (allowedFiles.indexOf(file) < 0) {
            removeFile(path_1.default.join(dir, file));
        }
    });
}
exports.cleanDir = cleanDir;
