"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.DIST_PATH = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const framework_core_1 = require("@cloudbase/framework-core");
const framework_plugin_mp_1 = require("@cloudbase/framework-plugin-mp");
const framework_plugin_website_1 = require("@cloudbase/framework-plugin-website");
const framework_plugin_auth_1 = require("@cloudbase/framework-plugin-auth");
const lowcode_builder_1 = require("@cloudbase/lowcode-builder");
const generate_1 = require("./generate");
const postProcess_1 = require("./utils/postProcess");
const lodash_1 = require("lodash");
const archiver_1 = __importDefault(require("archiver"));
const cos_nodejs_sdk_v5_1 = __importDefault(require("cos-nodejs-sdk-v5"));
const mpci = __importStar(require("miniprogram-ci"));
const qrcode_1 = __importDefault(require("qrcode"));
const url_1 = __importDefault(require("url"));
const private_1 = require("./config/private");
exports.DIST_PATH = './dist';
const DEBUG_PATH = './debug';
const QRCODE_PATH = './qrcode.jpg';
const LOG_FILE = 'build.log';
const DEFAULT_CLOUDFUNCTION_ROOT_NAME = 'cloudfunctions';
const DEFAULT_CLOUDFUNCTION_ROOT_PATH = path_1.default.join(DEFAULT_CLOUDFUNCTION_ROOT_NAME, '/');
const DEFAULT_INPUTS = {
    _inputFile: 'input.json',
    debug: false,
    runtime: process.env.CLOUDBASE_CIID ? lowcode_builder_1.RUNTIME.CI : lowcode_builder_1.RUNTIME.NONE,
    appId: 'test',
    buildTypeList: [lowcode_builder_1.BuildType.MP],
    generateMpType: lowcode_builder_1.GenerateMpType.APP,
    generateMpPath: '',
    subAppSerializeDataList: [],
    dependencies: [],
    plugins: [],
    operationService: {},
    extraData: { isComposite: false, compProps: {} },
    mpAppId: '',
    mpDeployPrivateKey: process.env.mpDeployPrivateKey || '',
    deployOptions: {
        mode: process.env.deployMode || lowcode_builder_1.DEPLOY_MODE.PREVIEW,
    },
    calsVersion: 'latest',
    ignoreInstall: false,
};
class LowCodePlugin extends framework_core_1.Plugin {
    constructor(name, api, inputs) {
        var _a, _b, _c;
        super(name, api, inputs);
        this.name = name;
        this.api = api;
        this.inputs = inputs;
        this._timeMap = {};
        this._domain = [];
        let inputJSONPath = path_1.default.resolve(this.api.projectPath, inputs._inputFile || DEFAULT_INPUTS._inputFile);
        let params = fs_extra_1.default.existsSync(inputJSONPath) ? fs_extra_1.default.readJsonSync(inputJSONPath) : {};
        this._resolvedInputs = resolveInputs(inputs, resolveInputs(params, DEFAULT_INPUTS));
        this._appPath = '';
        this._productBasePath = `lca/${this._resolvedInputs.appId}/${process.env.CLOUDBASE_CIID ? `/${process.env.CLOUDBASE_CIID}` : ''}`;
        let { envId } = this.api;
        if (!this._resolvedInputs.mainAppSerializeData) {
            throw new Error('缺少必须参数: mainAppSerializeData');
        }
        let map = {};
        this._resolvedInputs.dependencies = (this._resolvedInputs.dependencies || []).reduce((list, item) => {
            if (!map[`${item.name}@${item.version}`]) {
                map[`${item.name}@${item.version}`] = true;
                list.push(item);
            }
            return list;
        }, []);
        if (!this._resolvedInputs.mainAppSerializeData.extra) {
            this._resolvedInputs.mainAppSerializeData.extra = {};
        }
        if (!this._resolvedInputs.mainAppSerializeData.mpPkgUrl) {
            if (this._resolvedInputs.buildTypeList.includes(lowcode_builder_1.BuildType.APP) ||
                this._resolvedInputs.buildTypeList.includes(lowcode_builder_1.BuildType.XPAGE_PC) ||
                this._resolvedInputs.buildTypeList.includes(lowcode_builder_1.BuildType.ADMIN_PORTAL)) {
                this._resolvedInputs.mainAppSerializeData.extra.historyType = lowcode_builder_1.HISTORY_TYPE.HASH;
            }
        }
        if (!((_b = (_a = this._resolvedInputs.mainAppSerializeData) === null || _a === void 0 ? void 0 : _a.extra) === null || _b === void 0 ? void 0 : _b.envId)) {
            this._resolvedInputs.mainAppSerializeData.extra.envId = envId;
        }
        if ((0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList)) {
            const { appId, mainAppSerializeData } = this._resolvedInputs;
            let { appConfig = {} } = mainAppSerializeData.extra;
            let { window = {} } = appConfig;
            let path = this._getWebRootPath();
            window.publicPath = path;
            window.basename = (0, lowcode_builder_1.buildAsAdminPortalByBuildType)(this._resolvedInputs.buildTypeList)
                ? `app/${appId}${((_c = this._resolvedInputs.deployOptions) === null || _c === void 0 ? void 0 : _c.mode) !== lowcode_builder_1.DEPLOY_MODE.UPLOAD ? '-preview' : ''}`
                : (0, lowcode_builder_1.buildAsXPageByBuildType)(this._resolvedInputs.buildTypeList)
                    ? '/'
                    : path;
            appConfig.window = window;
            this._resolvedInputs.mainAppSerializeData.extra.appConfig = appConfig;
            this._resolvedInputs.subAppSerializeDataList = [];
            if (this._resolvedInputs.mainAppSerializeData.extra.miniprogramPlugins) {
                this._resolvedInputs.mainAppSerializeData.extra.miniprogramPlugins = [];
            }
        }
        else {
            const { mpAppId, mpDeployPrivateKey, deployOptions } = this._resolvedInputs;
            if (deployOptions.mpAppId === undefined) {
                deployOptions.mpAppId = mpAppId;
            }
            if (deployOptions.mpDeployPrivateKey === undefined) {
                deployOptions.mpDeployPrivateKey = mpDeployPrivateKey;
            }
            if (deployOptions.targetMpAppId === undefined) {
                deployOptions.targetMpAppId = deployOptions.mpAppId;
            }
        }
        this._initDir();
        this.api.logger.debug(`low-code plugin construct at ${Date.now()}`);
        this._time("low code lifetime");
    }
    _initDir() {
        fs_extra_1.default.emptyDirSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH));
        fs_extra_1.default.removeSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH));
    }
    _subPluginConstructor(resolveInputs) {
        var _a, _b;
        if (resolveInputs.runtime === lowcode_builder_1.RUNTIME.CLI) {
            return;
        }
        let { buildTypeList, deployOptions } = resolveInputs;
        this._authPlugin = new framework_plugin_auth_1.plugin('auth', this.api, {
            configs: [
                {
                    platform: 'NONLOGIN',
                    status: 'ENABLE',
                    platformId: '',
                    platformSecret: '',
                },
                {
                    platform: 'ANONYMOUS',
                    status: 'ENABLE',
                    platformId: '',
                    platformSecret: '',
                },
            ],
        });
        if (buildTypeList.includes(lowcode_builder_1.BuildType.MP)) {
            if (deployOptions.mpDeployPrivateKey) {
                fs_extra_1.default.writeFileSync(path_1.default.join(this.api.projectPath, `./private.${deployOptions.mpAppId}.key`), deployOptions.mpDeployPrivateKey, 'base64');
            }
            let projectJson = fs_extra_1.default.readJsonSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH, 'project.config.json'));
            let { cloudfunctionRoot, miniprogramRoot = './' } = projectJson;
            let setting = {
                es6: true,
                es7: true,
                minify: true,
                codeProtect: false,
            };
            this._miniprogramePlugin = new framework_plugin_mp_1.plugin('miniprograme', this.api, {
                appid: deployOptions.mpAppId,
                privateKeyPath: `./private.${deployOptions.mpAppId}.key`,
                localPath: exports.DIST_PATH,
                ignores: ['node_modules/**/*', LOG_FILE].concat(cloudfunctionRoot ? [path_1.default.join(cloudfunctionRoot, '**/*')] : []),
                deployMode: deployOptions.mpAppId === deployOptions.targetMpAppId ? deployOptions.mode : lowcode_builder_1.DEPLOY_MODE.UPLOAD,
                uploadOptions: {
                    version: (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.version) || '1.0.0',
                    desc: (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.description) || '',
                    setting,
                },
                previewOptions: {
                    qrcodeOutputPath: path_1.default.resolve(this.api.projectPath, QRCODE_PATH),
                    pagePath: (_b = (_a = fs_extra_1.default.readJsonSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH, miniprogramRoot, 'app.json'))) === null || _a === void 0 ? void 0 : _a.pages) === null || _b === void 0 ? void 0 : _b[0],
                    setting,
                },
            });
        }
        else if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList)) {
            this._webPlugin = new framework_plugin_website_1.plugin('web', this.api, {
                outputPath: exports.DIST_PATH,
                cloudPath: this._getWebRootPath(),
                ignore: ['.git', '.github', 'node_modules', 'cloudbaserc.js', LOG_FILE, DEFAULT_CLOUDFUNCTION_ROOT_NAME],
            });
        }
    }
    _getWebRootPath() {
        let { appId, deployOptions } = this._resolvedInputs;
        return (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.mode) === lowcode_builder_1.DEPLOY_MODE.PREVIEW ? `/${appId}/preview/` : `/${appId}/production/`;
    }
    _time(label) {
        if (!this._timeMap[label]) {
            this._timeMap[label] = Date.now();
        }
    }
    _timeEnd(label) {
        let startTime = this._timeMap[label];
        if (startTime) {
            let delta = Date.now() - startTime;
            return parseFloat((delta / 1000).toPrecision(2));
        }
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    remove() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    genCode() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    build() {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter(this, void 0, void 0, function* () {
            let { logger } = this.api;
            const staticDir = path_1.default.resolve(__dirname, '../../../static');
            let { debug, mainAppSerializeData, subAppSerializeDataList, dependencies, appId, buildTypeList, generateMpType, plugins, extraData = { isComposite: false, compProps: {} }, } = this._resolvedInputs;
            const webpackMode = ((_a = this._resolvedInputs.deployOptions) === null || _a === void 0 ? void 0 : _a.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD
                ? lowcode_builder_1.WebpackModeType.PRODUCTION
                : lowcode_builder_1.WebpackModeType.NONE;
            let miniAppDir = '';
            let webAppDir = '';
            const h5url = `./${appId}/index.html`;
            if (extraData.isComposite) {
                Object.keys(extraData.compProps.events).forEach((eName) => {
                    extraData.compProps.events[eName] = `$$EVENT_${eName}$$`;
                });
            }
            try {
                const { envId } = this.api;
                let [website, hostingDatas] = yield this._getHostingInfoTask(envId, true);
                this._website = website;
            }
            catch (e) {
                this.api.logger.error('获取静态托管失败: ', e);
                throw e;
            }
            const domain = ((_b = this._website) === null || _b === void 0 ? void 0 : _b.cdnDomain) || ((_c = mainAppSerializeData.extra) === null || _c === void 0 ? void 0 : _c.domain);
            if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList)) {
                let { appConfig = {} } = mainAppSerializeData.extra;
                let { window = {} } = appConfig;
                if ((0, lowcode_builder_1.buildAsXPageByBuildType)(buildTypeList)) {
                    window.publicPath =
                        ((_d = this._resolvedInputs.deployOptions) === null || _d === void 0 ? void 0 : _d.publicPath) || `https://${domain}${this._getWebRootPath()}`;
                }
                else if (this._resolvedInputs.deployOptions.mode === lowcode_builder_1.DEPLOY_MODE.UPLOAD) {
                    try {
                        const { Data = {} } = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                            Action: 'DescribeAppCustomUrls',
                            Param: {
                                EnvId: this.api.envId,
                                IgnorePublished: true,
                                WeAppId: appId,
                            },
                        });
                        this.api.logger.debug('DescribeAppCustomUrls:', (_e = Data === null || Data === void 0 ? void 0 : Data.Items) === null || _e === void 0 ? void 0 : _e[0]);
                        this._gatewayConfig = (_f = Data === null || Data === void 0 ? void 0 : Data.Items) === null || _f === void 0 ? void 0 : _f[0];
                        if (this._gatewayConfig) {
                            const path = this._gatewayConfig.Path;
                            window.publicPath = `https://${domain}${this._getWebRootPath()}`;
                            if (!(0, lowcode_builder_1.buildAsAdminPortalByBuildType)(buildTypeList)) {
                                window.basename = path;
                            }
                        }
                    }
                    catch (e) {
                        this.api.logger.error('路由失败', e, {
                            EnvId: this.api.envId,
                            IgnorePublished: true,
                            WeAppId: appId,
                        });
                    }
                }
                appConfig.window = window;
                this._resolvedInputs.mainAppSerializeData.extra.appConfig = appConfig;
            }
            try {
                if (!debug) {
                    pauseConsoleOutput();
                }
                this._time("build process");
                this._appPath = yield new Promise((resolve, reject) => {
                    try {
                        (0, lowcode_builder_1.buildWedaApp)({
                            cals: mainAppSerializeData,
                            subAppCalsList: subAppSerializeDataList,
                            dependencies,
                            appKey: appId,
                            runtime: this._resolvedInputs.runtime,
                            ignoreInstall: this._resolvedInputs.ignoreInstall,
                            buildTypeList,
                            mode: webpackMode,
                            deployOptions: this._resolvedInputs.deployOptions,
                            generateMpType,
                            plugins,
                            extraData,
                            resourceAppId: this._resolvedInputs.mpAppId,
                            domain,
                        }, (err, result) => __awaiter(this, void 0, void 0, function* () {
                            var _a;
                            if (!err) {
                                try {
                                    const { appConfig = {} } = mainAppSerializeData.extra;
                                    const { publicPath = '' } = (appConfig === null || appConfig === void 0 ? void 0 : appConfig.window) || {};
                                    const { outDir = '', timeElapsed = 0, plugins } = result || {};
                                    if (buildTypeList.includes(lowcode_builder_1.BuildType.MP)) {
                                        miniAppDir = outDir;
                                    }
                                    if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList)) {
                                        webAppDir = path_1.default.resolve(outDir, 'preview');
                                    }
                                    logger.debug(`=== Compilation finished at ${outDir}, elapsed time: ${timeElapsed / 1000}s.===\n`);
                                    if (buildTypeList.includes(lowcode_builder_1.BuildType.MP) && miniAppDir) {
                                        let projectJsonPath = path_1.default.resolve(miniAppDir, 'project.config.json');
                                        yield (0, postProcess_1.postprocessProjectConfig)(projectJsonPath, {
                                            appid: this._resolvedInputs.deployOptions.mpAppId,
                                            cloudfunctionRoot: undefined,
                                        });
                                        yield (0, postProcess_1.postprocessDeployExtraJson)(miniAppDir, this._resolvedInputs.deployOptions);
                                        if (generateMpType === lowcode_builder_1.GenerateMpType.APP) {
                                            fs_extra_1.default.removeSync(path_1.default.resolve(miniAppDir, 'miniprogram_npm'));
                                        }
                                        if (outDir) {
                                            if (plugins) {
                                                yield (0, generate_1.handleMpPlugins)(plugins, outDir);
                                            }
                                        }
                                    }
                                    else if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList) && webAppDir) {
                                        const staticAppDir = path_1.default.join(staticDir, publicPath);
                                        fs_extra_1.default.ensureDirSync(staticAppDir);
                                    }
                                    let distPath = path_1.default.resolve(this.api.projectPath, exports.DIST_PATH);
                                    if (miniAppDir) {
                                        fs_extra_1.default.copySync(miniAppDir, distPath);
                                    }
                                    else if (webAppDir) {
                                        fs_extra_1.default.copySync(webAppDir, distPath);
                                        if ((0, lowcode_builder_1.buildAsWebByBuildType)(buildTypeList) &&
                                            !(0, lowcode_builder_1.buildAsAdminPortalByBuildType)(buildTypeList) &&
                                            this._checkBroswerHisroty()) {
                                            yield Promise.all((((_a = this._resolvedInputs.mainAppSerializeData) === null || _a === void 0 ? void 0 : _a.items) || []).map((page) => fs_extra_1.default.copy(path_1.default.join(distPath, 'index.html'), path_1.default.join(distPath, page.id, 'index.html'))));
                                        }
                                    }
                                    resolve(distPath);
                                }
                                catch (e) {
                                    reject(e);
                                    throw e;
                                }
                            }
                            else {
                                if (err.length) {
                                    let messageList = (err[0] || '').split('\n');
                                    let lineIndex = 0;
                                    let reg = /node_modules\/@babel/;
                                    messageList.find((str, index) => {
                                        if (reg.test(str)) {
                                            lineIndex = index;
                                            return true;
                                        }
                                        else {
                                            return false;
                                        }
                                    });
                                    if (lineIndex) {
                                        messageList = messageList.slice(0, lineIndex);
                                    }
                                    let error = new Error(messageList.join('\n'));
                                    reject(error);
                                }
                                else {
                                    reject(err);
                                }
                            }
                        }));
                    }
                    catch (e) {
                        reject(e);
                    }
                });
                if (!debug) {
                    resumeConsoleOutput();
                }
                logger.info(`code generated successfully, cost ${this._timeEnd("build process")}s: ${this._appPath}`);
                this._subPluginConstructor(this._resolvedInputs);
                if (this._miniprogramePlugin) {
                    this._time("build mp plugin");
                    yield this._miniprogramePlugin.init();
                    try {
                        yield this.mpAnalyzeAndCleanCode(this._appPath);
                    }
                    catch (e) {
                        logger.info(`miniprogram stream line file: ${e}`);
                    }
                    yield this._miniprogramePlugin.build();
                    logger.debug(`miniprograme plugin build cost ${this._timeEnd("build mp plugin")}s`);
                }
                else if (this._webPlugin) {
                    this._time("build web plugin");
                    yield this._webPlugin.init();
                    yield this._webPlugin.build();
                    logger.debug(`website plugin build cost ${this._timeEnd("build web plugin")}s`);
                }
            }
            catch (e) {
                if (debug) {
                    yield this._debugInfo();
                }
                if (this._resolvedInputs.runtime === lowcode_builder_1.RUNTIME.CI) {
                    yield this._handleCIProduct();
                }
                logger.info(`low-code build fail: ${e}`);
                throw e;
            }
            logger.info(`low-code build end: ${this._appPath}`);
            return this._appPath;
        });
    }
    compile() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this._time("compile");
                let res = {};
                try {
                    yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                        Action: 'UpdateLoginConfig',
                        Param: { EnvId: this.api.envId },
                    });
                    this.api.logger.debug('login config set success');
                }
                catch (e) {
                    this.api.logger.error('设置登录配置失败', e);
                }
                if (this._miniprogramePlugin) {
                    res = (0, lodash_1.merge)(res, yield this._miniprogramePlugin.compile());
                }
                else if ((0, lowcode_builder_1.buildAsWebByBuildType)(this._resolvedInputs.buildTypeList) && this._webPlugin) {
                    try {
                        const HostingProvider = (_a = this.api.resourceProviders) === null || _a === void 0 ? void 0 : _a.hosting;
                        const { envId } = this.api;
                        let [website, hostingDatas] = yield this._getHostingInfoTask(envId, false);
                        if (HostingProvider) {
                            if (!hostingDatas) {
                                hostingDatas = (yield HostingProvider.getHostingInfo({ envId })).data;
                            }
                            let domains = hostingDatas.map((item) => item.cdnDomain);
                            this._domain = domains;
                        }
                        if (website) {
                            this._website = website;
                        }
                    }
                    catch (e) {
                        this.api.logger.error('获取静态托管失败: ', e);
                        throw e;
                    }
                    const privateJsPath = path_1.default.join('/', 'tmp', private_1.PRIVATE_JS_NAME);
                    try {
                        yield fs_extra_1.default.ensureFile(privateJsPath);
                        yield fs_extra_1.default.writeFile(privateJsPath, private_1.PRIVATE_JS_CODE, {
                            encoding: 'utf8',
                            flag: 'w',
                        });
                    }
                    catch (e) {
                        this.api.logger.error('创建私有化JS文件失败:', e);
                        throw e;
                    }
                    if (!(0, lowcode_builder_1.buildAsXPageByBuildType)(this._resolvedInputs.buildTypeList)) {
                        const deployContent = [
                            ...(this._webPlugin.buildOutput.static || []),
                            ...(this._webPlugin.buildOutput.staticConfig || []),
                            {
                                src: privateJsPath,
                                cloudPath: `/weda-config/${private_1.PRIVATE_JS_NAME}`,
                            },
                        ];
                        yield Promise.all(deployContent.map((options) => this.api.cloudbaseManager.hosting.uploadFiles({
                            localPath: options.src,
                            cloudPath: options.cloudPath,
                            ignore: this._webPlugin.resolvedInputs.ignore,
                        })));
                    }
                    else {
                        this.api.logger.info('xpage 跳过部署流程');
                    }
                }
                if (!Object.keys(res.Resources || {}).length && !Object.keys(res.Config || {}).length) {
                    this._skipInstallExt = true;
                }
                this.api.logger.info(`compile end, cost ${this._timeEnd("compile")}s: `, res);
                return res;
            }
            catch (e) {
                if (this._resolvedInputs.debug) {
                    yield this._debugInfo();
                }
                if (this._resolvedInputs.runtime === lowcode_builder_1.RUNTIME.CI) {
                    yield this._handleCIProduct();
                }
                throw e;
            }
        });
    }
    deploy() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this._time("DEPLOY");
                if (this._miniprogramePlugin) {
                    yield this._miniprogramePlugin.deploy();
                }
                else if (this._webPlugin) {
                    yield this._webPlugin.deploy();
                    if ((0, lowcode_builder_1.buildAsAdminPortalByBuildType)(this._resolvedInputs.buildTypeList)) {
                        yield this._postProcessAdminPortal();
                    }
                    else {
                        yield this._postProcessWebsiteConfig();
                    }
                    try {
                        let publishAppCustomNavRes = yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                            Action: 'PublishAppCustomNav',
                            Param: {
                                WeAppId: this._resolvedInputs.appId,
                                EnvId: this.api.envId,
                                PublishType: this._resolvedInputs.deployOptions.mode === lowcode_builder_1.DEPLOY_MODE.UPLOAD ? 'product' : 'preview',
                            },
                        });
                        this.api.logger.info(`${this.api.emoji('🚀')} custom publish success: ${JSON.stringify(publishAppCustomNavRes)}`);
                    }
                    catch (e) {
                        this.api.logger.error(`${this.api.emoji('🚀')} custom publish fail: ${JSON.stringify(e)}`);
                        if (((_a = e) === null || _a === void 0 ? void 0 : _a.code) !== 'ResourceNotFound') {
                            throw e;
                        }
                    }
                    try {
                        const { deployOptions, appId } = this._resolvedInputs;
                        const isPreview = (deployOptions === null || deployOptions === void 0 ? void 0 : deployOptions.mode) === lowcode_builder_1.DEPLOY_MODE.PREVIEW;
                        const link = (0, lowcode_builder_1.buildAsAdminPortalByBuildType)(this._resolvedInputs.buildTypeList)
                            ? `https://${this._website.cdnDomain}/adminportal/#/app/${isPreview ? `${appId}-preview` : appId}?envType=${isPreview ? 'preview' : 'prod'}`
                            : this._gatewayConfig
                                ? `https://${this._gatewayConfig.Domain + this._gatewayConfig.Path}`
                                : `https://${this._website.cdnDomain + this._webPlugin.resolvedInputs.cloudPath}`;
                        const qrcodeOutputPath = path_1.default.resolve(this.api.projectPath, QRCODE_PATH);
                        yield qrcode_1.default.toFile(path_1.default.resolve(this.api.projectPath, QRCODE_PATH), link, {
                            errorCorrectionLevel: 'M',
                            type: 'image/jpeg',
                            scale: 12,
                            margin: 2,
                        });
                        this.api.logger.info(`${this.api.emoji('🚀')} 网站部署成功：${link}`);
                        this.api.logger.info(`${this.api.emoji('🚀')} 网站部署成功, 访问二维码地址：${this.api.genClickableLink(url_1.default.format({
                            protocol: 'file:',
                            host: qrcodeOutputPath,
                        }))}`);
                    }
                    catch (e) {
                        this.api.logger.error('网站部署失败: ', e);
                        throw e;
                    }
                }
                if (this._skipInstallExt) {
                    try {
                        yield this.api.cloudApi.tcbService.request('CloudBaseCIResultCallback', {
                            CIID: this.api.ciId,
                            TraceId: this.api.ciId,
                            Status: 0,
                        });
                        this.api.logger.debug('回调云项目成功');
                    }
                    catch (e) {
                        this.api.logger.error('通知云项目状态失败[CloudBaseCIResultCallback]', e);
                    }
                }
                this.api.logger.info(`${this.api.emoji('🚀')} low - code deploy end, cost ${this._timeEnd("DEPLOY")}s`);
            }
            catch (e) {
                throw e;
            }
            finally {
                this.api.logger.debug(`low-code plugin takes ${this._timeEnd("low code lifetime")}s to run.`);
                if (this._resolvedInputs.debug) {
                    yield this._debugInfo();
                }
                if (this._resolvedInputs.runtime === lowcode_builder_1.RUNTIME.CI) {
                    yield this._handleCIProduct();
                    yield this._postPersistentDependiences();
                }
            }
            return;
        });
    }
    mpAnalyzeAndCleanCode(distDir) {
        return __awaiter(this, void 0, void 0, function* () {
            let { deployOptions } = this._resolvedInputs;
            const project = new mpci.Project({
                appid: deployOptions.mpAppId,
                projectPath: distDir,
                type: 'miniProgram',
                privateKeyPath: `./private.${deployOptions.mpAppId}.key`,
            });
            const analyseRes = yield mpci.analyseCode(project);
            if (analyseRes) {
                const codeExtensions = new Set(['.wxml', '.wxss', '.wxs', '.js', '.json', '.json', '.ts']);
                const { files } = analyseRes;
                const filesToDelete = files
                    .filter((f) => {
                    var _a, _b;
                    if (codeExtensions.has(f.ext) && !f.moduleId && ((_b = (_a = f.path) === null || _a === void 0 ? void 0 : _a.startsWith) === null || _b === void 0 ? void 0 : _b.call(_a, 'materials/'))) {
                        return true;
                    }
                    return false;
                })
                    .map((f) => f.path);
                this.api.logger.warn('-------------------filesToDelete', filesToDelete.join('\n'));
                yield Promise.all(filesToDelete.map((f) => __awaiter(this, void 0, void 0, function* () {
                    yield fs_extra_1.default.remove(path_1.default.join(distDir, f));
                })));
            }
            else {
                this.api.logger.warn('小程序代码静态分析失败');
            }
        });
    }
    _getHostingInfoTask(envId, loose = false) {
        return __awaiter(this, void 0, void 0, function* () {
            let timeout = null;
            let [website, hostingDatas] = yield Promise.race([
                new Promise((resolve) => {
                    timeout = setTimeout(() => {
                        resolve([]);
                    }, 300 * 1000);
                }),
                this._getHostingInfo(envId, loose),
            ]);
            if (timeout) {
                clearTimeout(timeout);
            }
            return [website, hostingDatas];
        });
    }
    _getHostingInfo(envId, loose = false) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const HostingProvider = (_a = this.api.resourceProviders) === null || _a === void 0 ? void 0 : _a.hosting;
            let [website, hostingDatas] = yield HostingProvider.getHostingInfo({
                envId,
            }).then(({ data: hostingDatas }) => {
                let website = hostingDatas[0];
                return [website, hostingDatas];
            });
            if (!website || (loose ? false : (website === null || website === void 0 ? void 0 : website.status) !== 'online')) {
                yield new Promise((resolve) => {
                    setTimeout(() => {
                        resolve(true);
                    }, 8 * 1000);
                });
                return this._getHostingInfo(envId, loose);
            }
            else {
                return [website, hostingDatas];
            }
        });
    }
    _checkIsVersion(version) {
        return version === 'latest' || String(version).startsWith('2');
    }
    _handleCIProduct() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                fs_extra_1.default.ensureDirSync(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH));
                const zipPath = path_1.default.resolve(this.api.projectPath, `${this._resolvedInputs.appId}.zip`);
                yield this._zipDir(path_1.default.resolve(this.api.projectPath, exports.DIST_PATH), zipPath);
                let { credential, storage } = this._resolvedInputs;
                let cos = (credential === null || credential === void 0 ? void 0 : credential.token)
                    ? new cos_nodejs_sdk_v5_1.default({
                        getAuthorization(options, callback) {
                            callback({
                                TmpSecretId: (credential === null || credential === void 0 ? void 0 : credential.secretId) || '',
                                TmpSecretKey: (credential === null || credential === void 0 ? void 0 : credential.secretKey) || '',
                                XCosSecurityToken: (credential === null || credential === void 0 ? void 0 : credential.token) || '',
                                ExpiredTime: Math.floor(Date.now() / 1000) + 600,
                                StartTime: Math.floor(Date.now() / 1000),
                            });
                        },
                    })
                    : new cos_nodejs_sdk_v5_1.default({
                        SecretId: credential === null || credential === void 0 ? void 0 : credential.secretId,
                        SecretKey: credential === null || credential === void 0 ? void 0 : credential.secretKey,
                    });
                yield new Promise((resolve, reject) => {
                    cos.putObject({
                        Bucket: (storage === null || storage === void 0 ? void 0 : storage.bucket) || '',
                        Region: (storage === null || storage === void 0 ? void 0 : storage.region) || '',
                        Key: `${this._productBasePath}/dist.zip`,
                        Body: fs_extra_1.default.createReadStream(zipPath),
                    }, (err, data) => {
                        if (err) {
                            reject(err);
                        }
                        else {
                            resolve(data);
                        }
                    });
                });
                fs_extra_1.default.removeSync(zipPath);
                if (fs_extra_1.default.existsSync(path_1.default.resolve(this.api.projectPath, QRCODE_PATH))) {
                    yield new Promise((resolve, reject) => {
                        cos.putObject({
                            Bucket: (storage === null || storage === void 0 ? void 0 : storage.bucket) || '',
                            Region: (storage === null || storage === void 0 ? void 0 : storage.region) || '',
                            Key: `${this._productBasePath}/qrcode.jpg`,
                            Body: fs_extra_1.default.createReadStream(path_1.default.resolve(this.api.projectPath, QRCODE_PATH)),
                        }, (err, data) => {
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve(data);
                            }
                        });
                    });
                }
                if (this._logFilePath) {
                    yield new Promise((resolve, reject) => {
                        cos.putObject({
                            Bucket: (storage === null || storage === void 0 ? void 0 : storage.bucket) || '',
                            Region: (storage === null || storage === void 0 ? void 0 : storage.region) || '',
                            Key: `${this._productBasePath}/${LOG_FILE}`,
                            Body: fs_extra_1.default.createReadStream(this._logFilePath),
                        }, (err, data) => {
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve(data);
                            }
                        });
                    });
                }
                if (fs_extra_1.default.existsSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH)) && this._resolvedInputs.debug) {
                    const zipPath = path_1.default.resolve(this.api.projectPath, `debug.zip`);
                    yield this._zipDir(path_1.default.resolve(this.api.projectPath, DEBUG_PATH), zipPath);
                    yield new Promise((resolve, reject) => {
                        cos.putObject({
                            Bucket: (storage === null || storage === void 0 ? void 0 : storage.bucket) || '',
                            Region: (storage === null || storage === void 0 ? void 0 : storage.region) || '',
                            Key: `${this._productBasePath}/debug.zip`,
                            Body: fs_extra_1.default.createReadStream(zipPath),
                        }, (err, data) => {
                            if (err) {
                                reject(err);
                            }
                            else {
                                resolve(data);
                            }
                        });
                    });
                }
                this.api.logger.info(`${this.api.emoji('🚀')} 上传制品成功。`);
            }
            catch (e) {
                this.api.logger.error(`${this.api.emoji('🚀')} 上传制品失败：`, e);
            }
        });
    }
    _postPersistentDependiences() {
        return __awaiter(this, void 0, void 0, function* () {
            let promises = [];
            let { credential } = this._resolvedInputs;
            let cos = (credential === null || credential === void 0 ? void 0 : credential.token)
                ? new cos_nodejs_sdk_v5_1.default({
                    getAuthorization(options, callback) {
                        callback({
                            TmpSecretId: (credential === null || credential === void 0 ? void 0 : credential.secretId) || '',
                            TmpSecretKey: (credential === null || credential === void 0 ? void 0 : credential.secretKey) || '',
                            XCosSecurityToken: (credential === null || credential === void 0 ? void 0 : credential.token) || '',
                            ExpiredTime: Math.floor(Date.now() / 1000) + 600,
                            StartTime: Math.floor(Date.now() / 1000),
                        });
                    },
                })
                : new cos_nodejs_sdk_v5_1.default({
                    SecretId: credential === null || credential === void 0 ? void 0 : credential.secretId,
                    SecretKey: credential === null || credential === void 0 ? void 0 : credential.secretKey,
                });
            promises = Object.keys(lowcode_builder_1.PERSISTENT_DEPENDIENCES_MAP).map((key) => __awaiter(this, void 0, void 0, function* () {
                let meta = lowcode_builder_1.PERSISTENT_DEPENDIENCES_MAP[key];
                const zipPath = path_1.default.join(this.api.projectPath, `${meta.name}@${meta.version}.zip`);
                try {
                    yield this._zipDir(meta.source, zipPath);
                    const matched = meta.downloadUrl.match(/^https?:\/\/(.*?)\.cos\.(.*?)\.myqcloud.com\/(.*)$/);
                    if (matched) {
                        const [_, bucket, region, cosKey] = matched;
                        this.api.logger.debug(`解析持久化地址`, matched);
                        if (bucket && region && cosKey) {
                            yield new Promise((resolve, reject) => {
                                cos.putObject({
                                    Bucket: bucket,
                                    Region: region,
                                    Key: cosKey,
                                    Body: fs_extra_1.default.createReadStream(zipPath),
                                }, (err, data) => {
                                    if (err) {
                                        reject(err);
                                    }
                                    else {
                                        resolve(data);
                                    }
                                });
                            });
                            this.api.logger.error(`持久化组件库${meta.name}@${meta.version}成功`);
                        }
                    }
                }
                catch (e) {
                    this.api.logger.error(`持久化组件库${meta.name}@${meta.version}失败：`, e);
                }
                return true;
            }));
            this.api.logger.info(`开始持久化组件库...`);
            yield Promise.all(promises);
        });
    }
    _debugInfo() {
        return __awaiter(this, void 0, void 0, function* () {
            fs_extra_1.default.ensureDirSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH));
            let _a = this._resolvedInputs, { mpDeployPrivateKey } = _a, _b = _a.deployOptions, { mpDeployPrivateKey: _key } = _b, restDeployOptions = __rest(_b, ["mpDeployPrivateKey"]), rest = __rest(_a, ["mpDeployPrivateKey", "deployOptions"]);
            fs_extra_1.default.writeJSONSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH, 'input.json'), Object.assign(Object.assign({}, rest), { deployOptions: Object.assign({}, restDeployOptions) }), { spaces: 2 });
            fs_extra_1.default.writeJSONSync(path_1.default.resolve(this.api.projectPath, DEBUG_PATH, 'env.json'), process.env, { spaces: 2 });
        });
    }
    _zipDir(src, dist) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                let output = fs_extra_1.default.createWriteStream(dist);
                let archive = (0, archiver_1.default)('zip', {
                    zlib: { level: 9 },
                });
                output.on('close', resolve);
                archive.on('error', reject);
                archive.directory(src, false);
                archive.pipe(output);
                archive.finalize();
            });
        });
    }
    _postProcessAdminPortal() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const { buildTypeList } = this._resolvedInputs;
            if ((0, lowcode_builder_1.buildAsAdminPortalByBuildType)(buildTypeList)) {
                try {
                    if (((_b = (_a = this._resolvedInputs) === null || _a === void 0 ? void 0 : _a.deployOptions) === null || _b === void 0 ? void 0 : _b.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD) {
                        yield this.api.cloudbaseManager.commonService('lowcode', '2021-01-08').call({
                            Action: 'PublishAppCustomUrl',
                            Param: {
                                EnvId: this.api.envId,
                                WeAppId: this._resolvedInputs.appId,
                            },
                        });
                    }
                    this.api.logger.info('PublishAppCustomUrl成功');
                }
                catch (e) {
                    this.api.logger.error('PublishAppCustomUrl失败: ', e);
                }
            }
        });
    }
    _postProcessWebsiteConfig() {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            const hostingService = this.api.cloudbaseManager.hosting;
            try {
                let domains = this._domain;
                let { Domains: domainList } = yield hostingService.tcbCheckResource({
                    domains,
                });
                if (!this._website) {
                    throw new Error('检查静态托管开通超时');
                }
                if (this._checkBroswerHisroty()) {
                    let { WebsiteConfiguration } = yield hostingService.getWebsiteConfig();
                    let path = this._getWebRootPath();
                    let rules = (WebsiteConfiguration.RoutingRules || []).reduce((arr, rule) => {
                        let meta = {};
                        let { Condition, Redirect } = rule;
                        if (Condition.HttpErrorCodeReturnedEquals) {
                            meta.httpErrorCodeReturnedEquals = Condition.HttpErrorCodeReturnedEquals;
                        }
                        if (Condition.KeyPrefixEquals) {
                            meta.keyPrefixEquals = Condition.KeyPrefixEquals;
                        }
                        if (Redirect.ReplaceKeyWith) {
                            meta.replaceKeyWith = Redirect.ReplaceKeyWith;
                        }
                        if (Redirect.ReplaceKeyPrefixWith) {
                            meta.replaceKeyPrefixWith = Redirect.ReplaceKeyPrefixWith;
                        }
                        if (`/${meta.keyPrefixEquals}`.startsWith(path)) {
                            return arr;
                        }
                        if (meta.httpErrorCodeReturnedEquals !== '404') {
                            arr.push(meta);
                        }
                        return arr;
                    }, []);
                    if (this._gatewayConfig) {
                        (_a = this._resolvedInputs.mainAppSerializeData.items) === null || _a === void 0 ? void 0 : _a.forEach((page) => {
                            rules.push({
                                keyPrefixEquals: `${path.slice(1)}${page.id}`,
                                replaceKeyWith: path,
                            });
                        });
                    }
                    this._rules = rules;
                }
                let modifyDomainConfigPromises = domainList
                    .filter((item) => item.DomainConfig.FollowRedirect !== 'on')
                    .map((item) => hostingService.tcbModifyAttribute({
                    domain: item.Domain,
                    domainId: item.DomainId,
                    domainConfig: { FollowRedirect: 'on' },
                }));
                yield Promise.all(modifyDomainConfigPromises);
                yield Promise.all([
                    ((_c = (_b = this._resolvedInputs) === null || _b === void 0 ? void 0 : _b.deployOptions) === null || _c === void 0 ? void 0 : _c.mode) === lowcode_builder_1.DEPLOY_MODE.UPLOAD
                        ? this.api.cloudbaseManager
                            .commonService('lowcode', '2021-01-08')
                            .call({
                            Action: 'PublishAppCustomUrl',
                            Param: {
                                EnvId: this.api.envId,
                                WeAppId: this._resolvedInputs.appId,
                                IndexPath: this._getWebRootPath(),
                            },
                        })
                            .catch((e) => {
                            this.api.logger.error('自定义域名发布失败: ', e);
                            if ((e === null || e === void 0 ? void 0 : e.code) !== 'ResourceNotFound') {
                                throw e;
                            }
                        })
                        : Promise.resolve(),
                    hostingService.setWebsiteDocument({
                        indexDocument: 'index.html',
                        routingRules: this._rules,
                    }),
                ]);
            }
            catch (e) {
                this.api.logger.error('网站路由注册失败: ', e);
                throw e;
            }
        });
    }
    _checkBroswerHisroty() {
        let historyType = this._resolvedInputs.mainAppSerializeData.extra.historyType ? lowcode_builder_1.HISTORY_TYPE.HASH : '';
        return !historyType || historyType === lowcode_builder_1.HISTORY_TYPE.BROWSER;
    }
}
function resolveInputs(inputs, defaultInputs) {
    return Object.assign({}, defaultInputs, inputs);
}
const originalStdoutWrite = process.stdout.write.bind(process.stdout);
const originalStderrWrite = process.stderr.write.bind(process.stderr);
let previousStdoutWrite = process.stdout.write.bind(process.stdout);
let previousStderrWrite = process.stderr.write.bind(process.stderr);
function pauseConsoleOutput() {
    previousStdoutWrite = process.stdout.write;
    process.stdout.write = () => true;
    previousStderrWrite = process.stderr.write.bind(process.stderr);
    process.stderr.write = () => true;
}
function resumeConsoleOutput(original = false) {
    if (original) {
        process.stdout.write = originalStdoutWrite;
        process.stderr.write = originalStderrWrite;
    }
    else {
        process.stdout.write = previousStdoutWrite;
        process.stderr.write = previousStderrWrite;
    }
}
exports.plugin = LowCodePlugin;
