"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IOSChannels = exports.IOSChannelTypes = exports.CodingPublishType = exports.H5BuildTypes = exports.ChannelTypes = exports.APPbuildStatus = exports.APPbuildModes = exports.APPbuildTypes = void 0;
var APPbuildTypes;
(function (APPbuildTypes) {
    APPbuildTypes[APPbuildTypes["Android"] = 1] = "Android";
    APPbuildTypes[APPbuildTypes["iOS"] = 2] = "iOS";
    APPbuildTypes[APPbuildTypes["web"] = 3] = "web";
    APPbuildTypes[APPbuildTypes["app"] = 4] = "app";
    APPbuildTypes[APPbuildTypes["qywxH5"] = 5] = "qywxH5";
    APPbuildTypes[APPbuildTypes["wxH5"] = 6] = "wxH5";
})(APPbuildTypes = exports.APPbuildTypes || (exports.APPbuildTypes = {}));
var APPbuildModes;
(function (APPbuildModes) {
    APPbuildModes[APPbuildModes["Production"] = 1] = "Production";
    APPbuildModes[APPbuildModes["Debugger"] = 2] = "Debugger";
})(APPbuildModes = exports.APPbuildModes || (exports.APPbuildModes = {}));
var APPbuildStatus;
(function (APPbuildStatus) {
    APPbuildStatus[APPbuildStatus["INITIALIZING"] = 0] = "INITIALIZING";
    APPbuildStatus[APPbuildStatus["RUNNING"] = 1] = "RUNNING";
    APPbuildStatus[APPbuildStatus["SUCCEED"] = 2] = "SUCCEED";
    APPbuildStatus[APPbuildStatus["FAILED"] = 3] = "FAILED";
})(APPbuildStatus = exports.APPbuildStatus || (exports.APPbuildStatus = {}));
exports.ChannelTypes = ['androidChannel', 'iOSChannel'];
exports.H5BuildTypes = [
    {
        value: 'web',
        label: "普通Web应用 （process.env.buildType = 'web'）",
    },
    {
        value: 'app',
        label: "Hybrid App内嵌h5 （process.env.buildType = 'app'）",
    },
    {
        value: 'qywxH5',
        label: "企业微信（政务微信）h5 （process.env.buildType = 'qywxH5'）",
    },
    {
        value: 'wxH5',
        label: "微信网页h5 （process.env.buildType = 'wxH5'）",
    },
];
var CodingPublishType;
(function (CodingPublishType) {
    CodingPublishType["Android"] = "android";
    CodingPublishType["iOS"] = "ios";
    CodingPublishType["H5"] = "h5";
})(CodingPublishType = exports.CodingPublishType || (exports.CodingPublishType = {}));
var IOSChannelTypes;
(function (IOSChannelTypes) {
    IOSChannelTypes["development"] = "development";
    IOSChannelTypes["adhoc"] = "ad-hoc";
    IOSChannelTypes["appStore"] = "app-store";
    IOSChannelTypes["enterprise"] = "enterprise";
})(IOSChannelTypes = exports.IOSChannelTypes || (exports.IOSChannelTypes = {}));
exports.IOSChannels = [
    {
        value: IOSChannelTypes.development,
        title: 'development测试分发',
        label: '用于给我们内部人员测试使用的，指定的授权用户设备才可以安装，可部署到服务器下载安装，需要开发证书打包',
    },
    {
        value: IOSChannelTypes.adhoc,
        title: 'ad-hoc测试分发',
        label: '用于给我们内部人员测试使用的，指定的授权用户设备才可以安装，可部署到服务器下载安装，需要发布证书打',
    },
    {
        value: IOSChannelTypes.appStore,
        title: 'app-store商店分发 ',
        label: '用于提交到商店审核，用户设备只能通过在App Store下载安装',
    },
    {
        value: IOSChannelTypes.enterprise,
        title: 'enterprise企业分发',
        label: '布署到服务器，所有用户设备都可通过扫描二维码或使用浏览器点击链接下载安装',
    },
];
